package com.ejie.ab79.service;
import com.ejie.ab79.dao.DatosEstablecimientoDao;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRequestDto;
import com.ejie.x38.dto.TableResponseDto;
import com.ejie.x38.dto.TableRowDto;
import java.util.List;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.ejie.ab79.model.DatosEstablecimiento;
import com.ejie.ab79.model.inspecciones.Inspecciones;

/**
 * DatosEstablecimientoServiceImpl  
 *  
 */

@Service(value = "datosEstablecimientoService")
public class DatosEstablecimientoServiceImpl implements DatosEstablecimientoService {

	@Autowired
	private DatosEstablecimientoDao datosEstablecimientoDao;

	/**
	 * Inserts a single row in the DatosEstablecimiento table.
	 *
	 * @param datosEstablecimiento DatosEstablecimiento
	 * @return DatosEstablecimiento
	 */
	@Transactional(rollbackFor = Throwable.class)
	public DatosEstablecimiento add(DatosEstablecimiento datosEstablecimiento) {
		return this.datosEstablecimientoDao.add(datosEstablecimiento);
	}

	/**
	 * Updates a single row in the DatosEstablecimiento table.
	 *
	 * @param datosEstablecimiento DatosEstablecimiento
	 * @return DatosEstablecimiento
	 */
	@Transactional(rollbackFor = Throwable.class)
	public DatosEstablecimiento update(DatosEstablecimiento datosEstablecimiento) {
		return this.datosEstablecimientoDao.update(datosEstablecimiento);
	 }

	/**
	 * Finds a single row in the DatosEstablecimiento table.
	 *
	 * @param datosEstablecimiento DatosEstablecimiento
	 * @return DatosEstablecimiento
	 */
	public DatosEstablecimiento find(DatosEstablecimiento datosEstablecimiento) {
		return (DatosEstablecimiento) this.datosEstablecimientoDao.find(datosEstablecimiento);
	}

	@Override
	public void removeByInspeccion(Inspecciones inspeccion) {
		this.datosEstablecimientoDao.removeByInspecciones(inspeccion);
	}
	
	/**
	 * Deletes a single row in the DatosEstablecimiento table.
	 *
	 * @param datosEstablecimiento DatosEstablecimiento
	 */
	@Transactional(rollbackFor = Throwable.class)
	public void remove(DatosEstablecimiento datosEstablecimiento) {
		this.datosEstablecimientoDao.remove(datosEstablecimiento);
	}

	/**
	 * Finds a list of rows in the DatosEstablecimiento table.
	 *
	 * @param datosEstablecimiento DatosEstablecimiento
	 * @param tableRequestDto TableRequestDto
	 * @return List<DatosEstablecimiento>
	 */
	public List<DatosEstablecimiento> findAll(DatosEstablecimiento datosEstablecimiento, TableRequestDto tableRequestDto){
		return (List<DatosEstablecimiento>) this.datosEstablecimientoDao.findAll(datosEstablecimiento, tableRequestDto);
	}
    
	/**
	 * Finds rows in the DatosEstablecimiento table using like.
	 *
	 * @param datosEstablecimiento DatosEstablecimiento
	 * @param tableRequestDto TableRequestDto
     * @param startsWith Boolean	 
	 * @return List<DatosEstablecimiento>
	 */
	public List<DatosEstablecimiento> findAllLike(DatosEstablecimiento datosEstablecimiento, TableRequestDto tableRequestDto, Boolean startsWith){
		return (List<DatosEstablecimiento>) this.datosEstablecimientoDao.findAllLike(datosEstablecimiento, tableRequestDto, startsWith);
	}
	
	@Override
	public DatosEstablecimiento findByInspeccion(Inspecciones inspeccion) {
		return this.datosEstablecimientoDao.findByInspeccion(inspeccion);
	}

	/*
	 * OPERACIONES RUP_TABLE
	 */
	 
	/**
	 * Removes rows from the DatosEstablecimiento table.
	 *
	 * @param filterDatosEstablecimiento DatosEstablecimiento
	 * @param tableRequestDto TableRequestDto
	 * @param startsWith Boolean
	 */	
	public void removeMultiple(DatosEstablecimiento filterDatosEstablecimiento, TableRequestDto tableRequestDto,  Boolean startsWith){
		this.datosEstablecimientoDao.removeMultiple(filterDatosEstablecimiento, tableRequestDto, startsWith);
	}
        
	/**
	 * Filter method in the DatosEstablecimiento table.
	 *
	 * @param filterDatosEstablecimiento DatosEstablecimiento
	 * @param tableRequestDto TableRequestDto
	 * @param startsWith Boolean
	 * @return TableResponseDto<DatosEstablecimiento>
	 */	
	public TableResponseDto< DatosEstablecimiento> filter(DatosEstablecimiento filterDatosEstablecimiento, TableRequestDto tableRequestDto,  Boolean startsWith){
		List<DatosEstablecimiento> listaDatosEstablecimiento =  this.datosEstablecimientoDao.findAllLike(filterDatosEstablecimiento, tableRequestDto, false);
		Long recordNum =  this.datosEstablecimientoDao.findAllLikeCount(filterDatosEstablecimiento != null ? filterDatosEstablecimiento: new DatosEstablecimiento (),false);
		
		TableResponseDto<DatosEstablecimiento> usuarioDto = new TableResponseDto<DatosEstablecimiento>(tableRequestDto, recordNum, listaDatosEstablecimiento);
		
		if (tableRequestDto.getMultiselection().getSelectedIds()!=null){
			List< TableRowDto< DatosEstablecimiento>> reorderSelection = this.datosEstablecimientoDao.reorderSelection(filterDatosEstablecimiento, tableRequestDto, startsWith);
			usuarioDto.setReorderedSelection(reorderSelection);
			usuarioDto.addAdditionalParam("reorderedSelection", reorderSelection);
			usuarioDto.addAdditionalParam("selectedAll", tableRequestDto.getMultiselection().getSelectedAll());
		}
		if (tableRequestDto.getSeeker().getSelectedIds()!=null){
			tableRequestDto.setMultiselection(tableRequestDto.getSeeker());
			List< TableRowDto< DatosEstablecimiento>> reorderSeeker = this.datosEstablecimientoDao.reorderSelection(filterDatosEstablecimiento, tableRequestDto, startsWith);
			usuarioDto.setReorderedSeeker(reorderSeeker);
			usuarioDto.addAdditionalParam("reorderedSeeker", reorderSeeker);
		}
		return usuarioDto;   
	}
    /**
	 * Searches rows in the DatosEstablecimiento table.
	 *
	 * @param filterDatosEstablecimiento DatosEstablecimiento
	 * @param searchDatosEstablecimiento DatosEstablecimiento
	 * @param tableRequestDto TableRequestDto
	 * @param startsWith Boolean
	 * @return List<TableRowDto<DatosEstablecimiento>>
	 */	
    public List< TableRowDto< DatosEstablecimiento>> search(DatosEstablecimiento filterDatosEstablecimiento, DatosEstablecimiento searchDatosEstablecimiento, TableRequestDto tableRequestDto, Boolean startsWith){
		return this.datosEstablecimientoDao.search(filterDatosEstablecimiento, searchDatosEstablecimiento, tableRequestDto, startsWith);
	}
    
    /**
	 * Reorder the selection made in DatosEstablecimiento table.
	 *
	 * @param filterDatosEstablecimiento DatosEstablecimiento
	 * @param tableRequestDto TableRequestDto
	 * @param startsWith Boolean
	 * @return Object
	 */	
    public Object reorderSelection(DatosEstablecimiento filterDatosEstablecimiento, TableRequestDto tableRequestDto, Boolean startsWith){
		return this.datosEstablecimientoDao.reorderSelection(filterDatosEstablecimiento, tableRequestDto, startsWith);
	}
    
    /*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */
	 
	/**
	 * Finder method in the hierarchical the DatosEstablecimiento table.
	 *
	 * @param filterDatosEstablecimiento DatosEstablecimiento
	 * @param tableRequestDto TableRequestDto
	 * @param startsWith Boolean
	 * @return TableResponseDto<JerarquiaDto<DatosEstablecimiento>>
	 */	
	public TableResponseDto<JerarquiaDto<DatosEstablecimiento>> jerarquia(DatosEstablecimiento filterDatosEstablecimiento, TableRequestDto tableRequestDto, Boolean startsWith){
		List<JerarquiaDto<DatosEstablecimiento>> listaDatosEstablecimiento =  this.datosEstablecimientoDao.findAllLikeJerarquia(filterDatosEstablecimiento, tableRequestDto);
		Long recordNum = this.datosEstablecimientoDao.findAllLikeCountJerarquia(filterDatosEstablecimiento, tableRequestDto);
		return new TableResponseDto<JerarquiaDto<DatosEstablecimiento>>(tableRequestDto, recordNum, listaDatosEstablecimiento);
	}
	
	/**
	 * Finder method for siblings rows in the hierarchical the DatosEstablecimiento table.
	 *
	 * @param filterDatosEstablecimiento DatosEstablecimiento
	 * @param tableRequestDto TableRequestDto
	 * @return TableResponseDto<JerarquiaDto<DatosEstablecimiento>>
	 */	
	public TableResponseDto<JerarquiaDto<DatosEstablecimiento>> jerarquiaChildren(DatosEstablecimiento filterDatosEstablecimiento, TableRequestDto tableRequestDto){
		TableResponseDto<JerarquiaDto<DatosEstablecimiento>> tableResponseDto = new TableResponseDto<JerarquiaDto<DatosEstablecimiento>>();
		tableResponseDto.addAdditionalParam(TableResponseDto.CHILDREN, this.datosEstablecimientoDao.findAllChild(filterDatosEstablecimiento, tableRequestDto));
		return tableResponseDto;
	}
	
	/**
    * Exporta Datos al clipBoard
    *
    */
    public List<DatosEstablecimiento> getMultiple(DatosEstablecimiento filterDatosEstablecimiento, TableRequestDto tableRequestDto,  Boolean startsWith){
		return this.datosEstablecimientoDao.getMultiple(filterDatosEstablecimiento, tableRequestDto, startsWith);
	}
	
}

